TITLE Two-Dimensional Table                (Base-Index.asm)

; Uses Base-Index and Base-index-displacement modes to 
; access two-dimensional arrays. 

; Last update: 5/30/2005

INCLUDE Irvine32.inc
INCLUDE macros.inc
      
; Returns the array value at a given row and column
; in tableD, a two-dimensional array of doublewords.
; Returns:  value in EAX

mGetVal MACRO rowIndex, columnIndex
	push	ebx
	push	esi
	mov	ebx,RowSizeD
	mov	eax,rowIndex
	mul	ebx	; EAX = row offset
	mov	esi,columnIndex
	mov	eax,tableD[eax + esi*TYPE tableD]
	pop	esi
	pop	ebx
ENDM        
    
; Prompts for a decimal integer, stores the value 
; entered by the user in returnVal. Do not pass
; EAX as returnVal.

mPromptInteger MACRO string, returnVal
	push	eax
	mWrite string
	call	ReadInt
	mov	returnVal,eax
	pop	eax
ENDM    
        
.data  
tableD DWORD 10000h,   20000h,  30000h,  40000h,  50000h
RowSizeD = ($ - tableD)
	  DWORD 60000h,   70000h,  80000h,  90000h, 0A0000h
       DWORD 0B0000h, 0C0000h, 0D0000h, 0E0000h, 0F0000h

row DWORD ?
col DWORD ?

.code
main PROC

; Use macros to display prompt strings.

	mPromptInteger "Enter row: ", row
	mPromptInteger "Enter column: ", col

; Use a macro to retrieve the array value.

	mGetVal row,col	; get tableD[row,column]
	
	mWrite "The value is: "
	call	WriteHex	; display EAX
	call	Crlf
	
	exit
main ENDP
END main