TITLE Two-Dimensional Table                (2Dtable.asm)

Comment !
Combines a macro with a procedure when calculating the sum of 
a row in a two-dimensional table of BYTE, WORD, or DWORD. 
Requires knowledge of IFIDNI

Last update: 5/31/05
!

INCLUDE Irvine32.inc
INCLUDE macros.inc

.data
tableB   DWORD  10h,  20h,  30h,  40h,  50h
RowSizeB = ($ - tableB)
         DWORD  60h,  70h,  80h,  90h,  0A0h
         DWORD  0B0h, 0C0h, 0D0h, 0E0h, 0F0h

tableW   DWORD  10h,  20h,  30h,  40h,  50h
RowSizeW = ($ - tableW)
         DWORD  60h,  70h,  80h,  90h,  0A0h
         DWORD  0B0h, 0C0h, 0D0h, 0E0h, 0F0h

tableD   DWORD  10h,  20h,  30h,  40h,  50h
RowSizeD = ($ - tableD)
         DWORD  60h,  70h,  80h,  90h,  0A0h
         DWORD  0B0h, 0C0h, 0D0h, 0E0h, 0F0h

index DWORD ?

;----------------------------------------------------------------
mCalc_row_sum MACRO index, arrayOffset, rowSize, eltType
; Calculates the sum of a row in a two-dimensional array.
;
; Receives: row index, offset of the array, number of bytes
;   in each table row, and the array type (BYTE, WORD, or DWORD).
; Returns:  EAX = sum.
;----------------------------------------------------------------
LOCAL L1
	push	ebx
	push	ecx
	push	esi

; set up the required registers
	mov	eax,index
	mov	ebx,arrayOffset
	mov	ecx,rowSize

; calculate the row offset.
	mul	ecx	; row index * row size
	add	ebx,eax	; row offset

; prepare the loop counter.	
	shr	ecx,(TYPE eltType / 2)	; byte=0, word=1, dword=2
	
; initialize the accumulator and column index	
	mov	eax,0	; accumulator
	mov	esi,0	; column index

L1:	
	IFIDNI <eltType>,<DWORD>
	  mov     edx,eltType PTR[ebx + esi*(TYPE eltType)]
	ELSE
	  movzx   edx,eltType PTR[ebx + esi*(TYPE eltType)]	
	ENDIF
	add	eax,edx	; add to accumulator
	inc	esi
	loop	L1
	
	pop	esi
	pop	ecx
	pop	ebx
ENDM

.code
main PROC

	mWrite "Enter row number [0-2]: "
	call	Readint	; EAX = row number
	mov	index,eax

	mCalc_row_sum index, OFFSET tableB, RowSizeB, BYTE
	mWrite "The sum is: "
	call	WriteHex	; write sum in EAX
	call	Crlf

	mCalc_row_sum index, OFFSET tableW, RowSizeW, WORD
	mWrite "The sum is: "
	call	WriteHex	; write sum in EAX
	call	Crlf

	mCalc_row_sum index, OFFSET tableD, RowSizeD, DWORD
	mWrite "The sum is: "
	call	WriteHex	; write sum in EAX
	call	Crlf

	exit
main ENDP

END main

